function y=Unit_Sat(u);


% Calcul des composantes de U dans le repre satellite

% u est le vecteur d'entre  7 composantes
% 	u(1:3) = U unitaire soleil en repre orbital
%	u(4:6) =OMEGA rotation abolue en axes satellite
%	u(7;10) est la quaternion d'attitude du satellite par 
%	rapport au repre orbital

Us(1:3)=u(1:3);

Q(1:4)=u(7:10);

% Cette fonction calcule la matrice de passage du repre orbital XYZ
% au repre satellite xyz, ceci pour raliser le changement de composantes
% Nouv_compos=Matrice Ancien_compos

% u est un quaternion et la fonction retourne y = Pmat la matrice de passage
% associe au changement de base


q0=Q(1);
q1=Q(2);
q2=Q(3);
q3=Q(4);

% Calcul de la matrice de passage

P11=2*(q0^2+q1^2)-1;P22=2*(q0^2+q2^2)-1;P33=2*(q0^2+q3^2)-1;
P21=2*(q1*q2+q0*q3);P12=2*(q1*q2-q0*q3);
P31=2*(q1*q3-q0*q2);P13=2*(q1*q3+q0*q2);
P32=2*(q2*q3+q0*q1);P23=2*(q2*q3-q0*q1);

Pmat=[P11 P12 P13;P21 P22 P23;P31 P32 P33];


y=inv(Pmat)*Us';                % Composantes de U en repre satellite Usat=inv(Pmat)*Uxyz

end;