function y=eclipses(u);

% ***********************************************************************
% La connaissance de H et jour, dans l'espace de travail est indispensable
% ***********************************************************************

global H jour rayon_orbital inclinaison vitesse_rotation periode_orbitale

tps=u;


% Fonction qui retourne 1 si le satellite est clair par le soleil
% et 0 dans le cas contraire

% u est le vecteur d'entre u=[H J t]
%	- H heure au noeud ascendant
%	- jour est le jour de l'anne civile
%	- tps est le temps orbital mesur depuis le passage au noeud acendant


% ***********************************************************************************

% Unitaire soleil

teta=15*(12-H)*pi/180;                                % Longitude nodale du soleil ( / Xn ), en radians

delta=23.45*sin(2*pi/365*(284+jour))*pi/180;          % Dclinaison en radians de Fletcher

Us=[cos(delta)*cos(teta) cos(delta)*sin(teta) sin(delta)];

% Rayon vecteur satellite

angle=vitesse_rotation*tps;


rayon_vecteur=[cos(angle) sin(angle)*cos(inclinaison) sin(angle)*sin(inclinaison)]*rayon_orbital;


% Norme du produit vectoriel

XX=[rayon_vecteur Us];

pv=prodvect(XX);

pv=norm(pv);

pv=(pv<=6378000);                      % Condition 1

% Produit scalaire

ps=rayon_vecteur*Us';

ps=(ps<=0);                           % Condition 2

% Conclusion

y=~(pv & ps);

end    % Fin programme


